// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: generator/integration_tests/test.proto

#include "generator/integration_tests/golden/golden_thing_admin_client.h"
#include "google/cloud/common_options.h"
#include "google/cloud/testing_util/example_driver.h"
#include <iostream>
#include <string>
#include <vector>

namespace {

void SetClientEndpoint(std::vector<std::string> const& argv) {
  if (!argv.empty()) {
    throw google::cloud::testing_util::Usage{"set-client-endpoint"};
  }
  //! [set-client-endpoint]
  // For illustration purposes, set the endpoint to the default value. In real
  // applications you would use a different value, such as a
  // `private.googleapis.com` for VPC-SC, or maybe a regional endpoint.
  auto options = google::cloud::Options{}.set<google::cloud::EndpointOption>(
      "test.googleapis.com");
  auto client = google::cloud::golden::GoldenThingAdminClient(
    google::cloud::golden::MakeGoldenThingAdminConnection(options));
  // Use the `client` object as usual
  //! [set-client-endpoint]
}

void AutoRun(std::vector<std::string> const& argv) {
  if (!argv.empty()) throw google::cloud::testing_util::Usage{"auto"};

  std::cout << "\nRunning SetClientEndpoint() example" << std::endl;
  SetClientEndpoint({});
}

}  // namespace

int main(int argc, char* argv[]) {  // NOLINT(bugprone-exception-escape)
  google::cloud::testing_util::Example example({
      {"set-client-endpoint", SetClientEndpoint},
      {"auto", AutoRun},
  });
  return example.Run(argc, argv);
}
