// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/devtools/artifactregistry/v1/service.proto

#include "google/cloud/artifactregistry/internal/artifact_registry_option_defaults.h"
#include "google/cloud/artifactregistry/artifact_registry_connection.h"
#include "google/cloud/artifactregistry/artifact_registry_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace artifactregistry_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options ArtifactRegistryDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_ARTIFACT_REGISTRY_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_ARTIFACT_REGISTRY_AUTHORITY",
      "artifactregistry.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<artifactregistry::ArtifactRegistryRetryPolicyOption>()) {
    options.set<artifactregistry::ArtifactRegistryRetryPolicyOption>(
        artifactregistry::ArtifactRegistryLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<artifactregistry::ArtifactRegistryBackoffPolicyOption>()) {
    options.set<artifactregistry::ArtifactRegistryBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options.has<artifactregistry::ArtifactRegistryPollingPolicyOption>()) {
    options.set<artifactregistry::ArtifactRegistryPollingPolicyOption>(
        GenericPollingPolicy<
            artifactregistry::ArtifactRegistryRetryPolicyOption::Type,
            artifactregistry::ArtifactRegistryBackoffPolicyOption::Type>(
            options.get<artifactregistry::ArtifactRegistryRetryPolicyOption>()
                ->clone(),
            options
                .get<artifactregistry::ArtifactRegistryBackoffPolicyOption>()
                ->clone())
            .clone());
  }
  if (!options.has<artifactregistry::
                       ArtifactRegistryConnectionIdempotencyPolicyOption>()) {
    options.set<
        artifactregistry::ArtifactRegistryConnectionIdempotencyPolicyOption>(
        artifactregistry::
            MakeDefaultArtifactRegistryConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace artifactregistry_internal
}  // namespace cloud
}  // namespace google
