// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/baremetalsolution/v2/baremetalsolution.proto

#include "google/cloud/baremetalsolution/internal/bare_metal_solution_option_defaults.h"
#include "google/cloud/baremetalsolution/bare_metal_solution_connection.h"
#include "google/cloud/baremetalsolution/bare_metal_solution_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace baremetalsolution_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options BareMetalSolutionDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_BARE_METAL_SOLUTION_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_BARE_METAL_SOLUTION_AUTHORITY",
      "baremetalsolution.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<baremetalsolution::BareMetalSolutionRetryPolicyOption>()) {
    options.set<baremetalsolution::BareMetalSolutionRetryPolicyOption>(
        baremetalsolution::BareMetalSolutionLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<baremetalsolution::BareMetalSolutionBackoffPolicyOption>()) {
    options.set<baremetalsolution::BareMetalSolutionBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options.has<baremetalsolution::BareMetalSolutionPollingPolicyOption>()) {
    options.set<baremetalsolution::BareMetalSolutionPollingPolicyOption>(
        GenericPollingPolicy<
            baremetalsolution::BareMetalSolutionRetryPolicyOption::Type,
            baremetalsolution::BareMetalSolutionBackoffPolicyOption::Type>(
            options
                .get<baremetalsolution::BareMetalSolutionRetryPolicyOption>()
                ->clone(),
            options
                .get<baremetalsolution::BareMetalSolutionBackoffPolicyOption>()
                ->clone())
            .clone());
  }
  if (!options.has<baremetalsolution::
                       BareMetalSolutionConnectionIdempotencyPolicyOption>()) {
    options.set<
        baremetalsolution::BareMetalSolutionConnectionIdempotencyPolicyOption>(
        baremetalsolution::
            MakeDefaultBareMetalSolutionConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace baremetalsolution_internal
}  // namespace cloud
}  // namespace google
