// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/batch/v1/batch.proto

#include "google/cloud/batch/internal/batch_option_defaults.h"
#include "google/cloud/batch/batch_connection.h"
#include "google/cloud/batch/batch_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace batch_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options BatchServiceDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_BATCH_SERVICE_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_BATCH_SERVICE_AUTHORITY", "batch.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<batch::BatchServiceRetryPolicyOption>()) {
    options.set<batch::BatchServiceRetryPolicyOption>(
        batch::BatchServiceLimitedTimeRetryPolicy(std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<batch::BatchServiceBackoffPolicyOption>()) {
    options.set<batch::BatchServiceBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options.has<batch::BatchServicePollingPolicyOption>()) {
    options.set<batch::BatchServicePollingPolicyOption>(
        GenericPollingPolicy<batch::BatchServiceRetryPolicyOption::Type,
                             batch::BatchServiceBackoffPolicyOption::Type>(
            options.get<batch::BatchServiceRetryPolicyOption>()->clone(),
            options.get<batch::BatchServiceBackoffPolicyOption>()->clone())
            .clone());
  }
  if (!options.has<batch::BatchServiceConnectionIdempotencyPolicyOption>()) {
    options.set<batch::BatchServiceConnectionIdempotencyPolicyOption>(
        batch::MakeDefaultBatchServiceConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace batch_internal
}  // namespace cloud
}  // namespace google
