# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# DO NOT EDIT -- GENERATED BY CMake -- Change the CMakeLists.txt file if needed

"""Automatically generated source lists for google_cloud_cpp_bigquery - DO NOT EDIT."""

google_cloud_cpp_bigquery_hdrs = [
    "analytics_hub_client.h",
    "analytics_hub_connection.h",
    "analytics_hub_connection_idempotency_policy.h",
    "analytics_hub_options.h",
    "bigquery_read_client.h",
    "bigquery_read_connection.h",
    "bigquery_read_connection_idempotency_policy.h",
    "bigquery_read_options.h",
    "bigquery_write_client.h",
    "bigquery_write_connection.h",
    "bigquery_write_connection_idempotency_policy.h",
    "bigquery_write_options.h",
    "connection_client.h",
    "connection_connection.h",
    "connection_connection_idempotency_policy.h",
    "connection_options.h",
    "data_transfer_client.h",
    "data_transfer_connection.h",
    "data_transfer_connection_idempotency_policy.h",
    "data_transfer_options.h",
    "internal/analytics_hub_auth_decorator.h",
    "internal/analytics_hub_connection_impl.h",
    "internal/analytics_hub_logging_decorator.h",
    "internal/analytics_hub_metadata_decorator.h",
    "internal/analytics_hub_option_defaults.h",
    "internal/analytics_hub_retry_traits.h",
    "internal/analytics_hub_stub.h",
    "internal/analytics_hub_stub_factory.h",
    "internal/bigquery_read_auth_decorator.h",
    "internal/bigquery_read_connection_impl.h",
    "internal/bigquery_read_logging_decorator.h",
    "internal/bigquery_read_metadata_decorator.h",
    "internal/bigquery_read_option_defaults.h",
    "internal/bigquery_read_retry_traits.h",
    "internal/bigquery_read_stub.h",
    "internal/bigquery_read_stub_factory.h",
    "internal/bigquery_write_auth_decorator.h",
    "internal/bigquery_write_connection_impl.h",
    "internal/bigquery_write_logging_decorator.h",
    "internal/bigquery_write_metadata_decorator.h",
    "internal/bigquery_write_option_defaults.h",
    "internal/bigquery_write_retry_traits.h",
    "internal/bigquery_write_stub.h",
    "internal/bigquery_write_stub_factory.h",
    "internal/connection_auth_decorator.h",
    "internal/connection_connection_impl.h",
    "internal/connection_logging_decorator.h",
    "internal/connection_metadata_decorator.h",
    "internal/connection_option_defaults.h",
    "internal/connection_retry_traits.h",
    "internal/connection_stub.h",
    "internal/connection_stub_factory.h",
    "internal/data_transfer_auth_decorator.h",
    "internal/data_transfer_connection_impl.h",
    "internal/data_transfer_logging_decorator.h",
    "internal/data_transfer_metadata_decorator.h",
    "internal/data_transfer_option_defaults.h",
    "internal/data_transfer_retry_traits.h",
    "internal/data_transfer_stub.h",
    "internal/data_transfer_stub_factory.h",
    "internal/migration_auth_decorator.h",
    "internal/migration_connection_impl.h",
    "internal/migration_logging_decorator.h",
    "internal/migration_metadata_decorator.h",
    "internal/migration_option_defaults.h",
    "internal/migration_retry_traits.h",
    "internal/migration_stub.h",
    "internal/migration_stub_factory.h",
    "internal/model_auth_decorator.h",
    "internal/model_connection_impl.h",
    "internal/model_logging_decorator.h",
    "internal/model_metadata_decorator.h",
    "internal/model_option_defaults.h",
    "internal/model_retry_traits.h",
    "internal/model_stub.h",
    "internal/model_stub_factory.h",
    "internal/reservation_auth_decorator.h",
    "internal/reservation_connection_impl.h",
    "internal/reservation_logging_decorator.h",
    "internal/reservation_metadata_decorator.h",
    "internal/reservation_option_defaults.h",
    "internal/reservation_retry_traits.h",
    "internal/reservation_stub.h",
    "internal/reservation_stub_factory.h",
    "migration_client.h",
    "migration_connection.h",
    "migration_connection_idempotency_policy.h",
    "migration_options.h",
    "model_client.h",
    "model_connection.h",
    "model_connection_idempotency_policy.h",
    "model_options.h",
    "reservation_client.h",
    "reservation_connection.h",
    "reservation_connection_idempotency_policy.h",
    "reservation_options.h",
    "retry_traits.h",
]

google_cloud_cpp_bigquery_srcs = [
    "analytics_hub_client.cc",
    "analytics_hub_connection.cc",
    "analytics_hub_connection_idempotency_policy.cc",
    "bigquery_read_client.cc",
    "bigquery_read_connection.cc",
    "bigquery_read_connection_idempotency_policy.cc",
    "bigquery_write_client.cc",
    "bigquery_write_connection.cc",
    "bigquery_write_connection_idempotency_policy.cc",
    "connection_client.cc",
    "connection_connection.cc",
    "connection_connection_idempotency_policy.cc",
    "data_transfer_client.cc",
    "data_transfer_connection.cc",
    "data_transfer_connection_idempotency_policy.cc",
    "internal/analytics_hub_auth_decorator.cc",
    "internal/analytics_hub_connection_impl.cc",
    "internal/analytics_hub_logging_decorator.cc",
    "internal/analytics_hub_metadata_decorator.cc",
    "internal/analytics_hub_option_defaults.cc",
    "internal/analytics_hub_stub.cc",
    "internal/analytics_hub_stub_factory.cc",
    "internal/bigquery_read_auth_decorator.cc",
    "internal/bigquery_read_connection_impl.cc",
    "internal/bigquery_read_logging_decorator.cc",
    "internal/bigquery_read_metadata_decorator.cc",
    "internal/bigquery_read_option_defaults.cc",
    "internal/bigquery_read_stub.cc",
    "internal/bigquery_read_stub_factory.cc",
    "internal/bigquery_write_auth_decorator.cc",
    "internal/bigquery_write_connection_impl.cc",
    "internal/bigquery_write_logging_decorator.cc",
    "internal/bigquery_write_metadata_decorator.cc",
    "internal/bigquery_write_option_defaults.cc",
    "internal/bigquery_write_stub.cc",
    "internal/bigquery_write_stub_factory.cc",
    "internal/connection_auth_decorator.cc",
    "internal/connection_connection_impl.cc",
    "internal/connection_logging_decorator.cc",
    "internal/connection_metadata_decorator.cc",
    "internal/connection_option_defaults.cc",
    "internal/connection_stub.cc",
    "internal/connection_stub_factory.cc",
    "internal/data_transfer_auth_decorator.cc",
    "internal/data_transfer_connection_impl.cc",
    "internal/data_transfer_logging_decorator.cc",
    "internal/data_transfer_metadata_decorator.cc",
    "internal/data_transfer_option_defaults.cc",
    "internal/data_transfer_stub.cc",
    "internal/data_transfer_stub_factory.cc",
    "internal/migration_auth_decorator.cc",
    "internal/migration_connection_impl.cc",
    "internal/migration_logging_decorator.cc",
    "internal/migration_metadata_decorator.cc",
    "internal/migration_option_defaults.cc",
    "internal/migration_stub.cc",
    "internal/migration_stub_factory.cc",
    "internal/model_auth_decorator.cc",
    "internal/model_connection_impl.cc",
    "internal/model_logging_decorator.cc",
    "internal/model_metadata_decorator.cc",
    "internal/model_option_defaults.cc",
    "internal/model_stub.cc",
    "internal/model_stub_factory.cc",
    "internal/reservation_auth_decorator.cc",
    "internal/reservation_connection_impl.cc",
    "internal/reservation_logging_decorator.cc",
    "internal/reservation_metadata_decorator.cc",
    "internal/reservation_option_defaults.cc",
    "internal/reservation_stub.cc",
    "internal/reservation_stub_factory.cc",
    "internal/streaming.cc",
    "migration_client.cc",
    "migration_connection.cc",
    "migration_connection_idempotency_policy.cc",
    "model_client.cc",
    "model_connection.cc",
    "model_connection_idempotency_policy.cc",
    "reservation_client.cc",
    "reservation_connection.cc",
    "reservation_connection_idempotency_policy.cc",
]
