// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/clouddms/v1/clouddms.proto

#include "google/cloud/datamigration/data_migration_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace datamigration {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

DataMigrationServiceConnectionIdempotencyPolicy::
    ~DataMigrationServiceConnectionIdempotencyPolicy() = default;

std::unique_ptr<DataMigrationServiceConnectionIdempotencyPolicy>
DataMigrationServiceConnectionIdempotencyPolicy::clone() const {
  return absl::make_unique<DataMigrationServiceConnectionIdempotencyPolicy>(
      *this);
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::ListMigrationJobs(
    google::cloud::clouddms::v1::ListMigrationJobsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::GetMigrationJob(
    google::cloud::clouddms::v1::GetMigrationJobRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::CreateMigrationJob(
    google::cloud::clouddms::v1::CreateMigrationJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::UpdateMigrationJob(
    google::cloud::clouddms::v1::UpdateMigrationJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::DeleteMigrationJob(
    google::cloud::clouddms::v1::DeleteMigrationJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::StartMigrationJob(
    google::cloud::clouddms::v1::StartMigrationJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::StopMigrationJob(
    google::cloud::clouddms::v1::StopMigrationJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::ResumeMigrationJob(
    google::cloud::clouddms::v1::ResumeMigrationJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
DataMigrationServiceConnectionIdempotencyPolicy::PromoteMigrationJob(
    google::cloud::clouddms::v1::PromoteMigrationJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::VerifyMigrationJob(
    google::cloud::clouddms::v1::VerifyMigrationJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
DataMigrationServiceConnectionIdempotencyPolicy::RestartMigrationJob(
    google::cloud::clouddms::v1::RestartMigrationJobRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency DataMigrationServiceConnectionIdempotencyPolicy::GenerateSshScript(
    google::cloud::clouddms::v1::GenerateSshScriptRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
DataMigrationServiceConnectionIdempotencyPolicy::ListConnectionProfiles(
    google::cloud::clouddms::v1::ListConnectionProfilesRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
DataMigrationServiceConnectionIdempotencyPolicy::GetConnectionProfile(
    google::cloud::clouddms::v1::GetConnectionProfileRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
DataMigrationServiceConnectionIdempotencyPolicy::CreateConnectionProfile(
    google::cloud::clouddms::v1::CreateConnectionProfileRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
DataMigrationServiceConnectionIdempotencyPolicy::UpdateConnectionProfile(
    google::cloud::clouddms::v1::UpdateConnectionProfileRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
DataMigrationServiceConnectionIdempotencyPolicy::DeleteConnectionProfile(
    google::cloud::clouddms::v1::DeleteConnectionProfileRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<DataMigrationServiceConnectionIdempotencyPolicy>
MakeDefaultDataMigrationServiceConnectionIdempotencyPolicy() {
  return absl::make_unique<DataMigrationServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace datamigration
}  // namespace cloud
}  // namespace google
