// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/datastream/v1/datastream.proto

#include "google/cloud/datastream/internal/datastream_option_defaults.h"
#include "google/cloud/datastream/datastream_connection.h"
#include "google/cloud/datastream/datastream_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace datastream_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options DatastreamDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_DATASTREAM_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_DATASTREAM_AUTHORITY", "datastream.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<datastream::DatastreamRetryPolicyOption>()) {
    options.set<datastream::DatastreamRetryPolicyOption>(
        datastream::DatastreamLimitedTimeRetryPolicy(std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<datastream::DatastreamBackoffPolicyOption>()) {
    options.set<datastream::DatastreamBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options.has<datastream::DatastreamPollingPolicyOption>()) {
    options.set<datastream::DatastreamPollingPolicyOption>(
        GenericPollingPolicy<datastream::DatastreamRetryPolicyOption::Type,
                             datastream::DatastreamBackoffPolicyOption::Type>(
            options.get<datastream::DatastreamRetryPolicyOption>()->clone(),
            options.get<datastream::DatastreamBackoffPolicyOption>()->clone())
            .clone());
  }
  if (!options.has<datastream::DatastreamConnectionIdempotencyPolicyOption>()) {
    options.set<datastream::DatastreamConnectionIdempotencyPolicyOption>(
        datastream::MakeDefaultDatastreamConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace datastream_internal
}  // namespace cloud
}  // namespace google
