// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/deploy/v1/cloud_deploy.proto

#include "google/cloud/deploy/internal/cloud_deploy_option_defaults.h"
#include "google/cloud/deploy/cloud_deploy_connection.h"
#include "google/cloud/deploy/cloud_deploy_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace deploy_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options CloudDeployDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_CLOUD_DEPLOY_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_CLOUD_DEPLOY_AUTHORITY", "clouddeploy.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<deploy::CloudDeployRetryPolicyOption>()) {
    options.set<deploy::CloudDeployRetryPolicyOption>(
        deploy::CloudDeployLimitedTimeRetryPolicy(std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<deploy::CloudDeployBackoffPolicyOption>()) {
    options.set<deploy::CloudDeployBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options.has<deploy::CloudDeployPollingPolicyOption>()) {
    options.set<deploy::CloudDeployPollingPolicyOption>(
        GenericPollingPolicy<deploy::CloudDeployRetryPolicyOption::Type,
                             deploy::CloudDeployBackoffPolicyOption::Type>(
            options.get<deploy::CloudDeployRetryPolicyOption>()->clone(),
            options.get<deploy::CloudDeployBackoffPolicyOption>()->clone())
            .clone());
  }
  if (!options.has<deploy::CloudDeployConnectionIdempotencyPolicyOption>()) {
    options.set<deploy::CloudDeployConnectionIdempotencyPolicyOption>(
        deploy::MakeDefaultCloudDeployConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace deploy_internal
}  // namespace cloud
}  // namespace google
