// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/networkmanagement/v1/reachability.proto

#include "google/cloud/networkmanagement/internal/reachability_option_defaults.h"
#include "google/cloud/networkmanagement/reachability_connection.h"
#include "google/cloud/networkmanagement/reachability_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace networkmanagement_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options ReachabilityServiceDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_REACHABILITY_SERVICE_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_REACHABILITY_SERVICE_AUTHORITY",
      "networkmanagement.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<networkmanagement::ReachabilityServiceRetryPolicyOption>()) {
    options.set<networkmanagement::ReachabilityServiceRetryPolicyOption>(
        networkmanagement::ReachabilityServiceLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options
           .has<networkmanagement::ReachabilityServiceBackoffPolicyOption>()) {
    options.set<networkmanagement::ReachabilityServiceBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options
           .has<networkmanagement::ReachabilityServicePollingPolicyOption>()) {
    options.set<networkmanagement::ReachabilityServicePollingPolicyOption>(
        GenericPollingPolicy<
            networkmanagement::ReachabilityServiceRetryPolicyOption::Type,
            networkmanagement::ReachabilityServiceBackoffPolicyOption::Type>(
            options
                .get<networkmanagement::ReachabilityServiceRetryPolicyOption>()
                ->clone(),
            options
                .get<
                    networkmanagement::ReachabilityServiceBackoffPolicyOption>()
                ->clone())
            .clone());
  }
  if (!options
           .has<networkmanagement::
                    ReachabilityServiceConnectionIdempotencyPolicyOption>()) {
    options.set<networkmanagement::
                    ReachabilityServiceConnectionIdempotencyPolicyOption>(
        networkmanagement::
            MakeDefaultReachabilityServiceConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace networkmanagement_internal
}  // namespace cloud
}  // namespace google
