// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/optimization/v1/fleet_routing.proto

#include "google/cloud/optimization/internal/fleet_routing_option_defaults.h"
#include "google/cloud/optimization/fleet_routing_connection.h"
#include "google/cloud/optimization/fleet_routing_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace optimization_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options FleetRoutingDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_FLEET_ROUTING_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_FLEET_ROUTING_AUTHORITY",
      "cloudoptimization.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<optimization::FleetRoutingRetryPolicyOption>()) {
    options.set<optimization::FleetRoutingRetryPolicyOption>(
        optimization::FleetRoutingLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<optimization::FleetRoutingBackoffPolicyOption>()) {
    options.set<optimization::FleetRoutingBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options.has<optimization::FleetRoutingPollingPolicyOption>()) {
    options.set<optimization::FleetRoutingPollingPolicyOption>(
        GenericPollingPolicy<
            optimization::FleetRoutingRetryPolicyOption::Type,
            optimization::FleetRoutingBackoffPolicyOption::Type>(
            options.get<optimization::FleetRoutingRetryPolicyOption>()->clone(),
            options.get<optimization::FleetRoutingBackoffPolicyOption>()
                ->clone())
            .clone());
  }
  if (!options.has<
          optimization::FleetRoutingConnectionIdempotencyPolicyOption>()) {
    options.set<optimization::FleetRoutingConnectionIdempotencyPolicyOption>(
        optimization::MakeDefaultFleetRoutingConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace optimization_internal
}  // namespace cloud
}  // namespace google
