// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/api/servicecontrol/v1/service_controller.proto

#include "google/cloud/servicecontrol/internal/service_controller_option_defaults.h"
#include "google/cloud/servicecontrol/service_controller_connection.h"
#include "google/cloud/servicecontrol/service_controller_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace servicecontrol_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options ServiceControllerDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_SERVICE_CONTROLLER_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_SERVICE_CONTROLLER_AUTHORITY",
      "servicecontrol.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<servicecontrol::ServiceControllerRetryPolicyOption>()) {
    options.set<servicecontrol::ServiceControllerRetryPolicyOption>(
        servicecontrol::ServiceControllerLimitedTimeRetryPolicy(
            std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<servicecontrol::ServiceControllerBackoffPolicyOption>()) {
    options.set<servicecontrol::ServiceControllerBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options.has<servicecontrol::
                       ServiceControllerConnectionIdempotencyPolicyOption>()) {
    options.set<
        servicecontrol::ServiceControllerConnectionIdempotencyPolicyOption>(
        servicecontrol::
            MakeDefaultServiceControllerConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace servicecontrol_internal
}  // namespace cloud
}  // namespace google
