// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/video/livestream/v1/service.proto

#include "google/cloud/video/internal/livestream_option_defaults.h"
#include "google/cloud/video/livestream_connection.h"
#include "google/cloud/video/livestream_options.h"
#include "google/cloud/internal/populate_common_options.h"
#include "google/cloud/internal/populate_grpc_options.h"
#include <memory>

namespace google {
namespace cloud {
namespace video_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

namespace {
auto constexpr kBackoffScaling = 2.0;
}  // namespace

Options LivestreamServiceDefaultOptions(Options options) {
  options = google::cloud::internal::PopulateCommonOptions(
      std::move(options), "GOOGLE_CLOUD_CPP_LIVESTREAM_SERVICE_ENDPOINT", "",
      "GOOGLE_CLOUD_CPP_LIVESTREAM_SERVICE_AUTHORITY",
      "livestream.googleapis.com");
  options =
      google::cloud::internal::PopulateGrpcOptions(std::move(options), "");
  if (!options.has<video::LivestreamServiceRetryPolicyOption>()) {
    options.set<video::LivestreamServiceRetryPolicyOption>(
        video::LivestreamServiceLimitedTimeRetryPolicy(std::chrono::minutes(30))
            .clone());
  }
  if (!options.has<video::LivestreamServiceBackoffPolicyOption>()) {
    options.set<video::LivestreamServiceBackoffPolicyOption>(
        ExponentialBackoffPolicy(std::chrono::seconds(1),
                                 std::chrono::minutes(5), kBackoffScaling)
            .clone());
  }
  if (!options.has<video::LivestreamServicePollingPolicyOption>()) {
    options.set<video::LivestreamServicePollingPolicyOption>(
        GenericPollingPolicy<video::LivestreamServiceRetryPolicyOption::Type,
                             video::LivestreamServiceBackoffPolicyOption::Type>(
            options.get<video::LivestreamServiceRetryPolicyOption>()->clone(),
            options.get<video::LivestreamServiceBackoffPolicyOption>()->clone())
            .clone());
  }
  if (!options
           .has<video::LivestreamServiceConnectionIdempotencyPolicyOption>()) {
    options.set<video::LivestreamServiceConnectionIdempotencyPolicyOption>(
        video::MakeDefaultLivestreamServiceConnectionIdempotencyPolicy());
  }

  return options;
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace video_internal
}  // namespace cloud
}  // namespace google
