// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/video/stitcher/v1/video_stitcher_service.proto

#include "google/cloud/video/internal/video_stitcher_logging_decorator.h"
#include "google/cloud/internal/log_wrapper.h"
#include "google/cloud/status_or.h"
#include <google/cloud/video/stitcher/v1/video_stitcher_service.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace video_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

VideoStitcherServiceLogging::VideoStitcherServiceLogging(
    std::shared_ptr<VideoStitcherServiceStub> child,
    TracingOptions tracing_options, std::set<std::string> components)
    : child_(std::move(child)),
      tracing_options_(std::move(tracing_options)),
      components_(std::move(components)) {}

StatusOr<google::cloud::video::stitcher::v1::CdnKey>
VideoStitcherServiceLogging::CreateCdnKey(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::CreateCdnKeyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::CreateCdnKeyRequest const&
                 request) { return child_->CreateCdnKey(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::ListCdnKeysResponse>
VideoStitcherServiceLogging::ListCdnKeys(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::ListCdnKeysRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::ListCdnKeysRequest const&
                 request) { return child_->ListCdnKeys(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::CdnKey>
VideoStitcherServiceLogging::GetCdnKey(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::GetCdnKeyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context,
          google::cloud::video::stitcher::v1::GetCdnKeyRequest const& request) {
        return child_->GetCdnKey(context, request);
      },
      context, request, __func__, tracing_options_);
}

Status VideoStitcherServiceLogging::DeleteCdnKey(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::DeleteCdnKeyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::DeleteCdnKeyRequest const&
                 request) { return child_->DeleteCdnKey(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::CdnKey>
VideoStitcherServiceLogging::UpdateCdnKey(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::UpdateCdnKeyRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::UpdateCdnKeyRequest const&
                 request) { return child_->UpdateCdnKey(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::VodSession>
VideoStitcherServiceLogging::CreateVodSession(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::CreateVodSessionRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::CreateVodSessionRequest const&
                 request) {
        return child_->CreateVodSession(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::VodSession>
VideoStitcherServiceLogging::GetVodSession(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::GetVodSessionRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::GetVodSessionRequest const&
                 request) { return child_->GetVodSession(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>
VideoStitcherServiceLogging::ListVodStitchDetails(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context,
          google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest const&
              request) {
        return child_->ListVodStitchDetails(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::VodStitchDetail>
VideoStitcherServiceLogging::GetVodStitchDetail(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::GetVodStitchDetailRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context,
          google::cloud::video::stitcher::v1::GetVodStitchDetailRequest const&
              request) { return child_->GetVodStitchDetail(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>
VideoStitcherServiceLogging::ListVodAdTagDetails(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context,
          google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest const&
              request) {
        return child_->ListVodAdTagDetails(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::VodAdTagDetail>
VideoStitcherServiceLogging::GetVodAdTagDetail(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest const&
                 request) {
        return child_->GetVodAdTagDetail(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>
VideoStitcherServiceLogging::ListLiveAdTagDetails(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context,
          google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest const&
              request) {
        return child_->ListLiveAdTagDetails(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::LiveAdTagDetail>
VideoStitcherServiceLogging::GetLiveAdTagDetail(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context,
          google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest const&
              request) { return child_->GetLiveAdTagDetail(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::Slate>
VideoStitcherServiceLogging::CreateSlate(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::CreateSlateRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::CreateSlateRequest const&
                 request) { return child_->CreateSlate(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::ListSlatesResponse>
VideoStitcherServiceLogging::ListSlates(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::ListSlatesRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::ListSlatesRequest const&
                 request) { return child_->ListSlates(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::Slate>
VideoStitcherServiceLogging::GetSlate(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::GetSlateRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](
          grpc::ClientContext& context,
          google::cloud::video::stitcher::v1::GetSlateRequest const& request) {
        return child_->GetSlate(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::Slate>
VideoStitcherServiceLogging::UpdateSlate(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::UpdateSlateRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::UpdateSlateRequest const&
                 request) { return child_->UpdateSlate(context, request); },
      context, request, __func__, tracing_options_);
}

Status VideoStitcherServiceLogging::DeleteSlate(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::DeleteSlateRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::DeleteSlateRequest const&
                 request) { return child_->DeleteSlate(context, request); },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::LiveSession>
VideoStitcherServiceLogging::CreateLiveSession(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::CreateLiveSessionRequest const&
        request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::CreateLiveSessionRequest const&
                 request) {
        return child_->CreateLiveSession(context, request);
      },
      context, request, __func__, tracing_options_);
}

StatusOr<google::cloud::video::stitcher::v1::LiveSession>
VideoStitcherServiceLogging::GetLiveSession(
    grpc::ClientContext& context,
    google::cloud::video::stitcher::v1::GetLiveSessionRequest const& request) {
  return google::cloud::internal::LogWrapper(
      [this](grpc::ClientContext& context,
             google::cloud::video::stitcher::v1::GetLiveSessionRequest const&
                 request) { return child_->GetLiveSession(context, request); },
      context, request, __func__, tracing_options_);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace video_internal
}  // namespace cloud
}  // namespace google
